summaryrefslogtreecommitdiffstats
path: root/teamspeak-client
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2013-02-20 11:46:26 +0000
committer Eric Hameleers <alien@slackware.com>2013-02-20 11:46:26 +0000
commit233b6ac60382af40432579a1b7e78a783b60b6f2 (patch)
tree5cae5c0edb637a8de99ede86abf9aa8d99101a20 /teamspeak-client
parente346604bf4ca4dfd783360cb47a32d40bf80a00e (diff)
downloadasb-233b6ac60382af40432579a1b7e78a783b60b6f2.tar.gz
asb-233b6ac60382af40432579a1b7e78a783b60b6f2.tar.xz
Initial revision
Diffstat (limited to 'teamspeak-client')
-rwxr-xr-xteamspeak-client/build/teamspeak-client.SlackBuild236
-rw-r--r--teamspeak-client/build/teamspeak39
2 files changed, 245 insertions, 0 deletions
diff --git a/teamspeak-client/build/teamspeak-client.SlackBuild b/teamspeak-client/build/teamspeak-client.SlackBuild
new file mode 100755
index 00000000..d1c3e113
--- /dev/null
+++ b/teamspeak-client/build/teamspeak-client.SlackBuild
@@ -0,0 +1,236 @@
+#!/bin/sh
+# $Id$
+# Copyright 2013 Eric Hameleers, eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: teamspeak-client
+# Descr: TeamSpeak Client - Voice Communication Software
+# URL: http://teamspeak.com/
+# Needs:
+# Changelog:
+# 3.0.9.2-1: 20/Feb/2013 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh teamspeak-client.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=teamspeak-client
+VERSION=${VERSION:-3.0.9.2}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="README*"
+
+# Automatically determine the architecture we're building on:
+MARCH=${ARCH:-$( uname -m )}
+case "$MARCH" in
+ i?86) export ARCH=i486 ; export PARCH=x86 ;;
+ x86_64) export ARCH=x86_64 ; export PARCH=amd64 ;;
+ *) echo "Not-supported architecture '$ARCH' !"; exit 1;;
+esac
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/TeamSpeak3-Client-linux_${PARCH}-${VERSION}.run"
+SRCURL="http://ftp.4players.de/pub/hosted/ts3/releases/${VERSION}/TeamSpeak3-Client-linux_${PARCH}-${VERSION}.run"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+
+# Need to manually accept a license:
+sh ${SOURCE}
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
+
+# Remove the Qt libraries as they just cause trouble with the system's Qt
+rm -f libQt*
+
+mkdir -p ${PKG}/opt/teamspeak3-client
+cp -R * ${PKG}/opt/teamspeak3-client/
+
+# Install a wrapper script:
+mkdir -p $PKG/usr/bin
+cp -a %SRCDIR/teamspeak3 $PKG/usr/bin/
+chmod 755 $PKG/usr/bin/teamspeak3
+
+# Rename the binary, we will call this binary from within our wrapper script:
+mv ${PKG}/opt/teamspeak3-client/ts3client_linux_* ${PKG}/opt/teamspeak3-client/ts3client
+
+# Create a desktop menu entry:
+mkdir -p $PKG/usr/share/{applications,pixmaps}
+cp -ia /opt/teamspeak3-client/gfx/default/24x24_connect.png \
+ $PKG/usr/share/pixmaps/teamspeak.png
+cat <<EOT > $PKG/usr/share/applications/teamspeak3.desktop
+[Desktop Entry]
+Encoding=UTF-8
+Name=teamspeak3
+GenericName=TeamSpeak3
+Comment=Voice Communication Software
+SwallowExec=
+Exec=teamspeak3
+MimeType=
+Icon=teamspeak.png
+Path=
+TerminalOptions=
+Terminal=false
+Type=Application
+Categories=Network;Audio
+EOT
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+# An example of how you handle your '.new' config files:
+#config etc/teamspeak-client.conf.new
+
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
+fi
+
+# Update hicolor theme cache:
+if [ -d usr/share/icons/hicolor ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
+ fi
+fi
+
+# Update the mime database:
+if [ -x usr/bin/update-mime-database ]; then
+ chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/teamspeak-client/build/teamspeak3 b/teamspeak-client/build/teamspeak3
new file mode 100644
index 00000000..b8ad1ad4
--- /dev/null
+++ b/teamspeak-client/build/teamspeak3
@@ -0,0 +1,9 @@
+#! /bin/sh
+
+BASEDIR="/opt/teamspeak3-client"
+export LD_LIBRARY_PATH="${BASEDIR}${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
+
+# Work around DT_RPATH (.) security issue by chdir'ing
+# into expected $LD_LIBRARY_PATH :
+cd "${BASEDIR}"
+exec "${BASEDIR}/ts3client" "$@"